PARAMETER filename,recno,lookfor,replacewith

DO CASE

	*---- for PRG
CASE _o_c_c_u_r.kind=="P"

	IF _DOS OR _UNIX
		KEYBOARD "{ctrl+home}{ctrl+f}"+m.lookfor+"{dnarrow}"+m.replacewith +"{ctrl+w}"
		DEFINE WINDOW prg FROM 0,0 TO 24,79 COLOR SCHEME 10 ;
			TITLE "  "+_o_c_c_u_r.path+" " FOOTER " Esc -> Cancel   Ctrl+W -> Save " ;
			FONT "system",12 ;
			CLOSE NOFLOAT NOGROW ZOOM
	ENDIF
	IF _WINDOWS OR _MAC
		KEYBOARD "{ctrl+home}{ctrl+f}"+m.lookfor+"{dnarrow}"+m.replacewith
		KEYBOARD "{dnarrow}{dnarrow}{dnarrow}{dnarrow}{dnarrow}{enter}"
		DEFINE WINDOW prg AT 0,0 SIZE 25,89.5;
			TITLE "  "+_o_c_c_u_r.path+" ";
			FONT "system",10 ;
			CLOSE NOFLOAT NOGROW NOZOOM
	ENDIF

	MODIFY COMM (m.filename) WINDOW prg

	SET STATUS BAR OFF

	*--- For snippets memo fields of DBF.
CASE _o_c_c_u_r.kind=="M"
	ACTIVATE WINDOW titres
	IF _WINDOWS OR _MAC
		IF _o_c_c_u_r.type=="DBF"
			@ 0.5,1 SAY PADC(adroite(ALLTRIM(_o_c_c_u_r.file)+".DBF",28)+"   Field : "+PADR(_o_c_c_u_r.object,10," ")+"   "+PADR("Clause : "+ALLTRIM(_o_c_c_u_r.clause),25),80)
		ELSE
			@ 0.5,1 SAY PADC(adroite(ALLTRIM(_o_c_c_u_r.file)+"."+ALLTRIM(_o_c_c_u_r.type),14)+"   Object : "+PADR(_o_c_c_u_r.object,10," ")+"   ";
				+PADR("Clause : "+ALLTRIM(_o_c_c_u_r.clause),25);
				+ IIF(INLIST (_o_c_c_u_r.type,"SCX","FRX","LBX") ,"   "+PROPER(_o_c_c_u_r.platform),"");
				,81)
		ENDIF
	ENDIF

	IF _DOS OR _UNIX
		IF _o_c_c_u_r.type=="DBF"
			@ 0,1 SAY PADC(adroite(ALLTRIM(_o_c_c_u_r.file)+".DBF",28)+"  Field : "+PADR(_o_c_c_u_r.object,10," ")+"  "+PADR("Clause : "+ALLTRIM(_o_c_c_u_r.clause),25),80)
		ELSE
			@ 0,1 SAY PADC(adroite(ALLTRIM(_o_c_c_u_r.file)+"."+ALLTRIM(_o_c_c_u_r.type),18)+" Object: "+PADR(_o_c_c_u_r.object,10," ")+"  "+PADR("Clause: "+ALLTRIM(_o_c_c_u_r.clause),25),60)+ ;
				IIF(INLIST (_o_c_c_u_r.type,"SCX","FRX","LBX") ,"   "+PROPER(platform),"")
		ENDIF
	ENDIF

	*-------- prepare Look For / Replace
	IF _DOS OR _UNIX
		KEYBOARD "{ctrl+home}{ctrl+f}"+m.lookfor+"{dnarrow}"+m.replacewith +"{ctrl+w}"
	ENDIF
	IF _WINDOWS OR _MAC
		KEYBOARD "{ctrl+home}{ctrl+f}"+m.lookfor+"{dnarrow}"+m.replacewith
		KEYBOARD "{dnarrow}{dnarrow}{dnarrow}{dnarrow}{dnarrow}{enter}"
	ENDIF

	*------------ Reach good record and edit
	GOTO (m.recno)
	IF EOF()
		?? CHR(7)+CHR(7)
		WAIT WINDOW "Cannot reach record: "+STR(m.recno)+CHR(13)+"edition canceled"
		RETURN
	ENDIF

	m.champ="_f_i_c."+ALLTRIM(_o_c_c_u_r.clause)

	***  editing a memo taking care of codepage ****
	SELECT _p_r_g
	REPLACE prg WITH EVAL(m.champ )
	MODIFY MEMO prg WINDOW modimemo SAVE
	SELECT _f_i_c
	REPLACE (_o_c_c_u_r.clause) WITH _p_r_g.prg

	HIDE WINDOW titres


	*-------- For DBF's fields other than MEMO
CASE _o_c_c_u_r.kind=="C" OR _o_c_c_u_r.kind=="N"
	ACTIVATE WINDOW titres
	CLEAR
	@ 0,0 SAY PADC("Field : "+_o_c_c_u_r.clause+"  CTRL+G continue        CTRL+E replace        ",77)
	ON KEY LABEL ctrl+G CONTINUE
	ON KEY LABEL ctrl+E DO Ireplace WITH _o_c_c_u_r.object,m.lookfor,m.replacewith,_o_c_c_u_r.field_type

	DO pointechamp WITH m.recno
	*============================
	BROWSE WINDOW modibrowse SAVE
	*============================

	ON KEY LABEL ctrl+G
	ON KEY LABEL ctrl+E


	*-------- For DBF's Fields of date type
CASE TYPE("_o_c_c_u_r.kind")=="D"
	ACTIVATE WINDOW titres
	CLEAR
	@ 0,0 SAY PADC("Field : "+_o_c_c_u_r.clause+"  CTRL+G continue        CTRL+E replace        ",77)

	ON KEY LABEL ctrl+G CONTINUE
	ON KEY LABEL ctrl+E DO Ireplace WITH _o_c_c_u_r.object,m.lookfor,m.replacewith,_o_c_c_u_r.field_type

	DO pointechamp WITH m.recno

	*============================
	BROWSE WINDOW modibrowse SAVE
	*============================

	ON KEY LABEL ctrl+G
	ON KEY LABEL ctrl+E


ENDCASE

*-----------------------------------------
procedure Ireplace
*-----------------------------------------
parameter M.Field,M.quoi,M.replacewith,M.type
private M.tempo
M.tempo=&Field
do case
  case M.type=="C"
    private M.i,M.tempo,M.deb
    M.i=1
    M.deb=0
    if M.touscas
      M.deb=at(upper(M.quoi),upper(&Field),M.i)
    else
      M.deb=at(M.quoi,&Field,M.i)
    endif

    M.tempo=&Field

    do while M.deb >0
      M.tempo=stuff(M.tempo,M.deb,len(M.quoi),M.replacewith) 
      M.i=M.i+1
      if M.touscas
        M.deb=at(upper(M.quoi),upper(&Field),M.i)
      else
        M.deb=at(M.quoi,&Field,M.i)
      endif
    enddo


  case M.type=="N"
    M.tempo=valnum(M.replacewith)
    
  case M.type=="D"
    M.tempo=valdate(M.replacewith)
endcase
replace &Field with M.tempo
continue
return
